
set echo on

set timing on

DECLARE

   CURSOR c_source IS
      SELECT *
      FROM   update_table;

   TYPE aat_whole_row IS TABLE OF c_source%ROWTYPE
      INDEX BY PLS_INTEGER;

   TYPE aat_id IS TABLE OF update_table.id%TYPE
      INDEX BY PLS_INTEGER;

   aa_rows aat_whole_row;
   aa_ids  aat_id;

BEGIN

   /* Fetch in one go as we are using small demo volumes... */
   OPEN c_source;
   FETCH c_source BULK COLLECT INTO aa_rows;
   CLOSE c_source;

   /* Process batch of data... */
   FOR i IN 1 .. aa_rows.COUNT LOOP

      --[complex processing goes here]--
      aa_rows(i).name := LOWER(aa_rows(i).name);
      aa_rows(i).type := LOWER(aa_rows(i).type);

      /* Assign IDs to PK array... */
      aa_ids(i) := aa_rows(i).id;

   END LOOP;

   /* FORALL update using SET ROW. Will update primary key... */
   FORALL i IN 1 .. aa_rows.COUNT
      UPDATE update_table
      SET    ROW = aa_rows(i)
      WHERE  id  = aa_ids(i);

   DBMS_OUTPUT.PUT_LINE( SQL%ROWCOUNT || ' rows updated.' );

END;
/


